# Class JTabbedPane

java.lang.Object
java.awt.Component
java.awt.Container
javax.swing.JComponent
javax.swing.JTabbedPane

All Implemented Interfaces:
  `ImageObserver, MenuContainer, Serializable, Accessible, SwingConstants`

@JavaBean(defaultProperty="UI", description="A component which provides a tab folder metaphor for displaying one component from a set of components.") public class JTabbedPane extends JComponent implements Serializable, Accessible, SwingConstants
A component that lets the user switch between a group of components by clicking on a tab with a given title and/or icon. For examples and information on using tabbed panes see How to Use Tabbed Panes, a section in The Java Tutorial.

Tabs/components are added to a `TabbedPane` object by using the `addTab` and `insertTab` methods. A tab is represented by an index corresponding to the position it was added in, where the first tab has an index equal to 0 and the last tab has an index equal to the tab count minus 1.

The `TabbedPane` uses a `SingleSelectionModel` to represent the set of tab indices and the currently selected index. If the tab count is greater than 0, then there will always be a selected index, which by default will be initialized to the first tab. If the tab count is 0, then the selected index will be -1.

The tab title can be rendered by a `Component`. For example, the following produce similar results:

    // In this case the look and feel renders the title for the tab.
    tabbedPane.addTab("Tab", myComponent);
    // In this case the custom component is responsible for rendering the
    // title of the tab.
    tabbedPane.addTab(null, myComponent);
    tabbedPane.setTabComponentAt(0, new JLabel("Tab"));

The latter is typically used when you want a more complex user interaction that requires custom components on the tab. For example, you could provide a custom component that animates or one that has widgets for closing the tab.

If you specify a component for a tab, the `JTabbedPane` will not render any text or icon you have specified for the tab.

Note: Do not use `setVisible` directly on a tab component to make it visible, use `setSelectedComponent` or `setSelectedIndex` methods instead.

Warning: Swing is not thread safe. For more information see Swing's Threading Policy.

Warning: Serialized objects of this class will not be compatible with future Swing releases. The current serialization support is appropriate for short term storage or RMI between applications running the same version of Swing. As of 1.4, support for long term storage of all JavaBeans has been added to the `java.beans` package. Please see `XMLEncoder`.

Since:
  1.2
See Also:
  - `SingleSelectionModel`

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `protected class`
  `JTabbedPane.AccessibleJTabbedPane`
  This class implements accessibility support for the `JTabbedPane` class.
  `protected class`
  `JTabbedPane.ModelListener`
  We pass `ModelChanged` events along to the listeners with the tabbedpane (instead of the model itself) as the event source.

  ### Nested classes/interfaces declared in class JComponent

  `JComponent.AccessibleJComponent`
  Modifier and Type
  Class
  Description
  `class`
  `JComponent.AccessibleJComponent`
  Inner class of JComponent used to provide default support for accessibility.

  ### Nested classes/interfaces declared in class Container

  `Container.AccessibleAWTContainer`
  Modifier and Type
  Class
  Description
  `protected class`
  `Container.AccessibleAWTContainer`
  Inner class of Container used to provide default support for accessibility.

  ### Nested classes/interfaces declared in class Component

  `Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`
  Modifier and Type
  Class
  Description
  `protected class`
  `Component.AccessibleAWTComponent`
  Inner class of Component used to provide default support for accessibility.
  `static enum`
  `Component.BaselineResizeBehavior`
  Enumeration of the common ways the baseline of a component can change as the size changes.
  `protected class`
  `Component.BltBufferStrategy`
  Inner class for blitting offscreen surfaces to a component.
  `protected class`
  `Component.FlipBufferStrategy`
  Inner class for flipping buffers on a component.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected ChangeEvent`
  `changeEvent`
  Only one `ChangeEvent` is needed per `TabPane` instance since the event's only (read-only) state is the source property.
  `protected ChangeListener`
  `changeListener`
  The `changeListener` is the listener we add to the model.
  `protected SingleSelectionModel`
  `model`
  The default selection model
  `static final int`
  `SCROLL_TAB_LAYOUT`
  Tab layout policy for providing a subset of available tabs when all the tabs will not fit within a single run.
  `protected int`
  `tabPlacement`
  Where the tabs are placed.
  `static final int`
  `WRAP_TAB_LAYOUT`
  The tab layout policy for wrapping tabs in multiple runs when all tabs will not fit within a single run.

  ### Fields declared in class JComponent

  `listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`
  Modifier and Type
  Field
  Description
  `protected EventListenerList`
  `listenerList`
  A list of event listeners for this component.
  `static final String`
  `TOOL_TIP_TEXT_KEY`
  The comment to display when the cursor is over the component, also known as a "value tip", "flyover help", or "flyover label".
  `protected ComponentUI`
  `ui`
  The look and feel delegate for this component.
  `static final int`
  `UNDEFINED_CONDITION`
  Constant used by some of the APIs to mean that no condition is defined.
  `static final int`
  `WHEN_ANCESTOR_OF_FOCUSED_COMPONENT`
  Constant used for `registerKeyboardAction` that means that the command should be invoked when the receiving component is an ancestor of the focused component or is itself the focused component.
  `static final int`
  `WHEN_FOCUSED`
  Constant used for `registerKeyboardAction` that means that the command should be invoked when the component has the focus.
  `static final int`
  `WHEN_IN_FOCUSED_WINDOW`
  Constant used for `registerKeyboardAction` that means that the command should be invoked when the receiving component is in the window that has the focus or is itself the focused component.

  ### Fields declared in class Component

  `accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`
  Modifier and Type
  Field
  Description
  `protected AccessibleContext`
  `accessibleContext`
  The `AccessibleContext` associated with this `Component`.
  `static final float`
  `BOTTOM_ALIGNMENT`
  Ease-of-use constant for `getAlignmentY`.
  `static final float`
  `CENTER_ALIGNMENT`
  Ease-of-use constant for `getAlignmentY` and `getAlignmentX`.
  `static final float`
  `LEFT_ALIGNMENT`
  Ease-of-use constant for `getAlignmentX`.
  `static final float`
  `RIGHT_ALIGNMENT`
  Ease-of-use constant for `getAlignmentX`.
  `static final float`
  `TOP_ALIGNMENT`
  Ease-of-use constant for `getAlignmentY()`.

  ### Fields declared in interface ImageObserver

  `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`
  Modifier and Type
  Field
  Description
  `static final int`
  `ABORT`
  This flag in the infoflags argument to imageUpdate indicates that an image which was being tracked asynchronously was aborted before production was complete.
  `static final int`
  `ALLBITS`
  This flag in the infoflags argument to imageUpdate indicates that a static image which was previously drawn is now complete and can be drawn again in its final form.
  `static final int`
  `ERROR`
  This flag in the infoflags argument to imageUpdate indicates that an image which was being tracked asynchronously has encountered an error.
  `static final int`
  `FRAMEBITS`
  This flag in the infoflags argument to imageUpdate indicates that another complete frame of a multi-frame image which was previously drawn is now available to be drawn again.
  `static final int`
  `HEIGHT`
  This flag in the infoflags argument to imageUpdate indicates that the height of the base image is now available and can be taken from the height argument to the imageUpdate callback method.
  `static final int`
  `PROPERTIES`
  This flag in the infoflags argument to imageUpdate indicates that the properties of the image are now available.
  `static final int`
  `SOMEBITS`
  This flag in the infoflags argument to imageUpdate indicates that more pixels needed for drawing a scaled variation of the image are available.
  `static final int`
  `WIDTH`
  This flag in the infoflags argument to imageUpdate indicates that the width of the base image is now available and can be taken from the width argument to the imageUpdate callback method.

  ### Fields declared in interface SwingConstants

  `BOTTOM, CENTER, EAST, HORIZONTAL, LEADING, LEFT, NEXT, NORTH, NORTH_EAST, NORTH_WEST, PREVIOUS, RIGHT, SOUTH, SOUTH_EAST, SOUTH_WEST, TOP, TRAILING, VERTICAL, WEST`
  Modifier and Type
  Field
  Description
  `static final int`
  `BOTTOM`
  Box-orientation constant used to specify the bottom of a box.
  `static final int`
  `CENTER`
  The central position in an area.
  `static final int`
  `EAST`
  Compass-direction east (right).
  `static final int`
  `HORIZONTAL`
  Horizontal orientation.
  `static final int`
  `LEADING`
  Identifies the leading edge of text for use with left-to-right and right-to-left languages.
  `static final int`
  `LEFT`
  Box-orientation constant used to specify the left side of a box.
  `static final int`
  `NEXT`
  Identifies the next direction in a sequence.
  `static final int`
  `NORTH`
  Compass-direction North (up).
  `static final int`
  `NORTH_EAST`
  Compass-direction north-east (upper right).
  `static final int`
  `NORTH_WEST`
  Compass-direction north west (upper left).
  `static final int`
  `PREVIOUS`
  Identifies the previous direction in a sequence.
  `static final int`
  `RIGHT`
  Box-orientation constant used to specify the right side of a box.
  `static final int`
  `SOUTH`
  Compass-direction south (down).
  `static final int`
  `SOUTH_EAST`
  Compass-direction south-east (lower right).
  `static final int`
  `SOUTH_WEST`
  Compass-direction south-west (lower left).
  `static final int`
  `TOP`
  Box-orientation constant used to specify the top of a box.
  `static final int`
  `TRAILING`
  Identifies the trailing edge of text for use with left-to-right and right-to-left languages.
  `static final int`
  `VERTICAL`
  Vertical orientation.
  `static final int`
  `WEST`
  Compass-direction west (left).

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `JTabbedPane()`
  Creates an empty `TabbedPane` with a default tab placement of `JTabbedPane.TOP`.
  `JTabbedPane(int tabPlacement)`
  Creates an empty `TabbedPane` with the specified tab placement of either: `JTabbedPane.TOP`, `JTabbedPane.BOTTOM`, `JTabbedPane.LEFT`, or `JTabbedPane.RIGHT`.
  `JTabbedPane(int tabPlacement, int tabLayoutPolicy)`
  Creates an empty `TabbedPane` with the specified tab placement and tab layout policy.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Component`
  `add(Component component)`
  Adds a `component` with a tab title defaulting to the name of the component which is the result of calling `component.getName`.
  `Component`
  `add(Component component, int index)`
  Adds a `component` at the specified tab index with a tab title defaulting to the name of the component.
  `void`
  `add(Component component, Object constraints)`
  Adds a `component` to the tabbed pane.
  `void`
  `add(Component component, Object constraints, int index)`
  Adds a `component` at the specified tab index.
  `Component`
  `add(String title, Component component)`
  Adds a `component` with the specified tab title.
  `void`
  `addChangeListener(ChangeListener l)`
  Adds a `ChangeListener` to this tabbedpane.
  `void`
  `addTab(String title, Component component)`
  Adds a `component` represented by a `title` and no icon.
  `void`
  `addTab(String title, Icon icon, Component component)`
  Adds a `component` represented by a `title` and/or `icon`, either of which can be `null`.
  `void`
  `addTab(String title, Icon icon, Component component, String tip)`
  Adds a `component` and `tip` represented by a `title` and/or `icon`, either of which can be `null`.
  `protected ChangeListener`
  `createChangeListener()`
  Subclasses that want to handle `ChangeEvents` differently can override this to return a subclass of `ModelListener` or another `ChangeListener` implementation.
  `protected void`
  `fireStateChanged()`
  Sends a `ChangeEvent`, with this `JTabbedPane` as the source, to each registered listener.
  `AccessibleContext`
  `getAccessibleContext()`
  Gets the AccessibleContext associated with this JTabbedPane.
  `Color`
  `getBackgroundAt(int index)`
  Returns the tab background color at `index`.
  `Rectangle`
  `getBoundsAt(int index)`
  Returns the tab bounds at `index`.
  `ChangeListener[]`
  `getChangeListeners()`
  Returns an array of all the `ChangeListener`s added to this `JTabbedPane` with `addChangeListener`.
  `Component`
  `getComponentAt(int index)`
  Returns the component at `index`.
  `Icon`
  `getDisabledIconAt(int index)`
  Returns the tab disabled icon at `index`.
  `int`
  `getDisplayedMnemonicIndexAt(int tabIndex)`
  Returns the character, as an index, that the look and feel should provide decoration for as representing the mnemonic character.
  `Color`
  `getForegroundAt(int index)`
  Returns the tab foreground color at `index`.
  `Icon`
  `getIconAt(int index)`
  Returns the tab icon at `index`.
  `int`
  `getMnemonicAt(int tabIndex)`
  Returns the keyboard mnemonic for accessing the specified tab.
  `SingleSelectionModel`
  `getModel()`
  Returns the model associated with this tabbedpane.
  `Component`
  `getSelectedComponent()`
  Returns the currently selected component for this tabbedpane.
  `int`
  `getSelectedIndex()`
  Returns the currently selected index for this tabbedpane.
  `Component`
  `getTabComponentAt(int index)`
  Returns the tab component at `index`.
  `int`
  `getTabCount()`
  Returns the number of tabs in this `tabbedpane`.
  `int`
  `getTabLayoutPolicy()`
  Returns the policy used by the tabbedpane to layout the tabs when all the tabs will not fit within a single run.
  `int`
  `getTabPlacement()`
  Returns the placement of the tabs for this tabbedpane.
  `int`
  `getTabRunCount()`
  Returns the number of tab runs currently used to display the tabs.
  `String`
  `getTitleAt(int index)`
  Returns the tab title at `index`.
  `String`
  `getToolTipText(MouseEvent event)`
  Returns the tooltip text for the component determined by the mouse event location.
  `String`
  `getToolTipTextAt(int index)`
  Returns the tab tooltip text at `index`.
  `TabbedPaneUI`
  `getUI()`
  Returns the UI object which implements the L&F for this component.
  `String`
  `getUIClassID()`
  Returns the name of the UI class that implements the L&F for this component.
  `int`
  `indexAtLocation(int x, int y)`
  Returns the tab index corresponding to the tab whose bounds intersect the specified location.
  `int`
  `indexOfComponent(Component component)`
  Returns the index of the tab for the specified component.
  `int`
  `indexOfTab(String title)`
  Returns the first tab index with a given `title`, or -1 if no tab has this title.
  `int`
  `indexOfTab(Icon icon)`
  Returns the first tab index with a given `icon`, or -1 if no tab has this icon.
  `int`
  `indexOfTabComponent(Component tabComponent)`
  Returns the index of the tab for the specified tab component.
  `void`
  `insertTab(String title, Icon icon, Component component, String tip, int index)`
  Inserts a new tab for the given component, at the given index, represented by the given title and/or icon, either of which may be `null`.
  `boolean`
  `isEnabledAt(int index)`
  Returns whether or not the tab at `index` is currently enabled.
  `protected String`
  `paramString()`
  Returns a string representation of this `JTabbedPane`.
  `void`
  `remove(int index)`
  Removes the tab and component which corresponds to the specified index.
  `void`
  `remove(Component component)`
  Removes the specified `Component` from the `JTabbedPane`.
  `void`
  `removeAll()`
  Removes all the tabs and their corresponding components from the `tabbedpane`.
  `void`
  `removeChangeListener(ChangeListener l)`
  Removes a `ChangeListener` from this tabbedpane.
  `void`
  `removeTabAt(int index)`
  Removes the tab at `index`.
  `void`
  `setBackgroundAt(int index, Color background)`
  Sets the background color at `index` to `background` which can be `null`, in which case the tab's background color will default to the background color of the `tabbedpane`.
  `void`
  `setComponentAt(int index, Component component)`
  Sets the component at `index` to `component`.
  `void`
  `setDisabledIconAt(int index, Icon disabledIcon)`
  Sets the disabled icon at `index` to `icon` which can be `null`.
  `void`
  `setDisplayedMnemonicIndexAt(int tabIndex, int mnemonicIndex)`
  Provides a hint to the look and feel as to which character in the text should be decorated to represent the mnemonic.
  `void`
  `setEnabledAt(int index, boolean enabled)`
  Sets whether or not the tab at `index` is enabled.
  `void`
  `setForegroundAt(int index, Color foreground)`
  Sets the foreground color at `index` to `foreground` which can be `null`, in which case the tab's foreground color will default to the foreground color of this `tabbedpane`.
  `void`
  `setIconAt(int index, Icon icon)`
  Sets the icon at `index` to `icon` which can be `null`.
  `void`
  `setMnemonicAt(int tabIndex, int mnemonic)`
  Sets the keyboard mnemonic for accessing the specified tab.
  `void`
  `setModel(SingleSelectionModel model)`
  Sets the model to be used with this tabbedpane.
  `void`
  `setSelectedComponent(Component c)`
  Sets the selected component for this tabbedpane.
  `void`
  `setSelectedIndex(int index)`
  Sets the selected index for this tabbedpane.
  `void`
  `setTabComponentAt(int index, Component component)`
  Sets the component that is responsible for rendering the title for the specified tab.
  `void`
  `setTabLayoutPolicy(int tabLayoutPolicy)`
  Sets the policy which the tabbedpane will use in laying out the tabs when all the tabs will not fit within a single run.
  `void`
  `setTabPlacement(int tabPlacement)`
  Sets the tab placement for this tabbedpane.
  `void`
  `setTitleAt(int index, String title)`
  Sets the title at `index` to `title` which can be `null`.
  `void`
  `setToolTipTextAt(int index, String toolTipText)`
  Sets the tooltip text at `index` to `toolTipText` which can be `null`.
  `void`
  `setUI(TabbedPaneUI ui)`
  Sets the UI object which implements the L&F for this component.
  `void`
  `updateUI()`
  Resets the UI property to a value from the current look and feel.

  ### Methods declared in class JComponent

  `addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`
  Modifier and Type
  Method
  Description
  `void`
  `addAncestorListener(AncestorListener listener)`
  Registers `listener` so that it will receive `AncestorEvents` when it or any of its ancestors move or are made visible or invisible.
  `void`
  `addNotify()`
  Notifies this component that it now has a parent component.
  `void`
  `addVetoableChangeListener(VetoableChangeListener listener)`
  Adds a `VetoableChangeListener` to the listener list.
  `void`
  `computeVisibleRect(Rectangle visibleRect)`
  Returns the `Component`'s "visible rect rectangle" - the intersection of the visible rectangles for this component and all of its ancestors.
  `boolean`
  `contains(int x, int y)`
  Gives the UI delegate an opportunity to define the precise shape of this component for the sake of mouse processing.
  `JToolTip`
  `createToolTip()`
  Returns the instance of `JToolTip` that should be used to display the tooltip.
  `void`
  `disable()`
  Deprecated.
  As of JDK version 1.1, replaced by `java.awt.Component.setEnabled(boolean)`.
  `void`
  `enable()`
  Deprecated.
  As of JDK version 1.1, replaced by `java.awt.Component.setEnabled(boolean)`.
  `void`
  `firePropertyChange(String propertyName, boolean oldValue, boolean newValue)`
  Support for reporting bound property changes for boolean properties.
  `void`
  `firePropertyChange(String propertyName, int oldValue, int newValue)`
  Support for reporting bound property changes for integer properties.
  `protected void`
  `fireVetoableChange(String propertyName, Object oldValue, Object newValue)`
  Supports reporting constrained property changes.
  `ActionListener`
  `getActionForKeyStroke(KeyStroke aKeyStroke)`
  Returns the object that will perform the action registered for a given keystroke.
  `final ActionMap`
  `getActionMap()`
  Returns the `ActionMap` used to determine what `Action` to fire for particular `KeyStroke` binding.
  `float`
  `getAlignmentX()`
  Overrides `Container.getAlignmentX` to return the horizontal alignment.
  `float`
  `getAlignmentY()`
  Overrides `Container.getAlignmentY` to return the vertical alignment.
  `AncestorListener[]`
  `getAncestorListeners()`
  Returns an array of all the ancestor listeners registered on this component.
  `boolean`
  `getAutoscrolls()`
  Gets the `autoscrolls` property.
  `int`
  `getBaseline(int width, int height)`
  Returns the baseline.
  `Component.BaselineResizeBehavior`
  `getBaselineResizeBehavior()`
  Returns an enum indicating how the baseline of the component changes as the size changes.
  `Border`
  `getBorder()`
  Returns the border of this component or `null` if no border is currently set.
  `Rectangle`
  `getBounds(Rectangle rv)`
  Stores the bounds of this component into "return value" `rv` and returns `rv`.
  `final Object`
  `getClientProperty(Object key)`
  Returns the value of the property with the specified key.
  `protected Graphics`
  `getComponentGraphics(Graphics g)`
  Returns the graphics object used to paint this component.
  `JPopupMenu`
  `getComponentPopupMenu()`
  Returns `JPopupMenu` that assigned for this component.
  `int`
  `getConditionForKeyStroke(KeyStroke aKeyStroke)`
  Returns the condition that determines whether a registered action occurs in response to the specified keystroke.
  `int`
  `getDebugGraphicsOptions()`
  Returns the state of graphics debugging.
  `static Locale`
  `getDefaultLocale()`
  Returns the default locale used to initialize each JComponent's locale property upon creation.
  `FontMetrics`
  `getFontMetrics(Font font)`
  Gets the `FontMetrics` for the specified `Font`.
  `Graphics`
  `getGraphics()`
  Returns this component's graphics context, which lets you draw on a component.
  `int`
  `getHeight()`
  Returns the current height of this component.
  `boolean`
  `getInheritsPopupMenu()`
  Returns true if the JPopupMenu should be inherited from the parent.
  `final InputMap`
  `getInputMap()`
  Returns the `InputMap` that is used when the component has focus.
  `final InputMap`
  `getInputMap(int condition)`
  Returns the `InputMap` that is used during `condition`.
  `InputVerifier`
  `getInputVerifier()`
  Returns the input verifier for this component.
  `Insets`
  `getInsets()`
  If a border has been set on this component, returns the border's insets; otherwise calls `super.getInsets`.
  `Insets`
  `getInsets(Insets insets)`
  Returns an `Insets` object containing this component's inset values.
  `<T extends EventListener>
  T[]`
  `getListeners(Class<T> listenerType)`
  Returns an array of all the objects currently registered as `FooListener`s upon this `JComponent`.
  `Point`
  `getLocation(Point rv)`
  Stores the x,y origin of this component into "return value" `rv` and returns `rv`.
  `Dimension`
  `getMaximumSize()`
  If the maximum size has been set to a non-`null` value just returns it.
  `Dimension`
  `getMinimumSize()`
  If the minimum size has been set to a non-`null` value just returns it.
  `Component`
  `getNextFocusableComponent()`
  Deprecated.
  As of 1.4, replaced by `FocusTraversalPolicy`.
  `Point`
  `getPopupLocation(MouseEvent event)`
  Returns the preferred location to display the popup menu in this component's coordinate system.
  `Dimension`
  `getPreferredSize()`
  If the `preferredSize` has been set to a non-`null` value just returns it.
  `KeyStroke[]`
  `getRegisteredKeyStrokes()`
  Returns the `KeyStrokes` that will initiate registered actions.
  `JRootPane`
  `getRootPane()`
  Returns the `JRootPane` ancestor for this component.
  `Dimension`
  `getSize(Dimension rv)`
  Stores the width/height of this component into "return value" `rv` and returns `rv`.
  `Point`
  `getToolTipLocation(MouseEvent event)`
  Returns the tooltip location in this component's coordinate system.
  `String`
  `getToolTipText()`
  Returns the tooltip string that has been set with `setToolTipText`.
  `Container`
  `getTopLevelAncestor()`
  Returns the top-level ancestor of this component (the containing `Window`) or `null` if this component has not been added to any container.
  `TransferHandler`
  `getTransferHandler()`
  Gets the `transferHandler` property.
  `boolean`
  `getVerifyInputWhenFocusTarget()`
  Returns the value that indicates whether the input verifier for the current focus owner will be called before this component requests focus.
  `VetoableChangeListener[]`
  `getVetoableChangeListeners()`
  Returns an array of all the vetoable change listeners registered on this component.
  `Rectangle`
  `getVisibleRect()`
  Returns the `Component`'s "visible rectangle" - the intersection of this component's visible rectangle, `new Rectangle(0, 0, getWidth(), getHeight())`, and all of its ancestors' visible rectangles.
  `int`
  `getWidth()`
  Returns the current width of this component.
  `int`
  `getX()`
  Returns the current x coordinate of the component's origin.
  `int`
  `getY()`
  Returns the current y coordinate of the component's origin.
  `void`
  `grabFocus()`
  Requests that this Component get the input focus, and that this Component's top-level ancestor become the focused Window.
  `void`
  `hide()`
  Deprecated.
  `boolean`
  `isDoubleBuffered()`
  Returns whether this component should use a buffer to paint.
  `static boolean`
  `isLightweightComponent(Component c)`
  Returns true if this component is lightweight, that is, if it doesn't have a native window system peer.
  `boolean`
  `isManagingFocus()`
  Deprecated.
  As of 1.4, replaced by `Component.setFocusTraversalKeys(int, Set)` and `Container.setFocusCycleRoot(boolean)`.
  `boolean`
  `isOpaque()`
  Returns true if this component is completely opaque.
  `boolean`
  `isOptimizedDrawingEnabled()`
  Returns true if this component tiles its children -- that is, if it can guarantee that the children will not overlap.
  `final boolean`
  `isPaintingForPrint()`
  Returns `true` if the current painting operation on this component is part of a `print` operation.
  `protected boolean`
  `isPaintingOrigin()`
  Returns `true` if a paint triggered on a child component should cause painting to originate from this Component, or one of its ancestors.
  `boolean`
  `isPaintingTile()`
  Returns true if the component is currently painting a tile.
  `boolean`
  `isRequestFocusEnabled()`
  Returns `true` if this `JComponent` should get focus; otherwise returns `false`.
  `boolean`
  `isValidateRoot()`
  If this method returns true, `revalidate` calls by descendants of this component will cause the entire tree beginning with this root to be validated.
  `void`
  `paint(Graphics g)`
  Invoked by Swing to draw components.
  `protected void`
  `paintBorder(Graphics g)`
  Paints the component's border.
  `protected void`
  `paintChildren(Graphics g)`
  Paints this component's children.
  `protected void`
  `paintComponent(Graphics g)`
  Calls the UI delegate's paint method, if the UI delegate is non-`null`.
  `void`
  `paintImmediately(int x, int y, int w, int h)`
  Paints the specified region in this component and all of its descendants that overlap the region, immediately.
  `void`
  `paintImmediately(Rectangle r)`
  Paints the specified region now.
  `void`
  `print(Graphics g)`
  Invoke this method to print the component to the specified `Graphics`.
  `void`
  `printAll(Graphics g)`
  Invoke this method to print the component.
  `protected void`
  `printBorder(Graphics g)`
  Prints the component's border.
  `protected void`
  `printChildren(Graphics g)`
  Prints this component's children.
  `protected void`
  `printComponent(Graphics g)`
  This is invoked during a printing operation.
  `protected void`
  `processComponentKeyEvent(KeyEvent e)`
  Processes any key events that the component itself recognizes.
  `protected boolean`
  `processKeyBinding(KeyStroke ks, KeyEvent e, int condition, boolean pressed)`
  Invoked to process the key bindings for `ks` as the result of the `KeyEvent` `e`.
  `protected void`
  `processKeyEvent(KeyEvent e)`
  Overrides `processKeyEvent` to process events.
  `protected void`
  `processMouseEvent(MouseEvent e)`
  Processes mouse events occurring on this component by dispatching them to any registered `MouseListener` objects, refer to `Component.processMouseEvent(MouseEvent)` for a complete description of this method.
  `protected void`
  `processMouseMotionEvent(MouseEvent e)`
  Processes mouse motion events, such as MouseEvent.MOUSE_DRAGGED.
  `final void`
  `putClientProperty(Object key, Object value)`
  Adds an arbitrary key/value "client property" to this component.
  `void`
  `registerKeyboardAction(ActionListener anAction, String aCommand, KeyStroke aKeyStroke, int aCondition)`
  This method is now obsolete, please use a combination of `getActionMap()` and `getInputMap()` for similar behavior.
  `void`
  `registerKeyboardAction(ActionListener anAction, KeyStroke aKeyStroke, int aCondition)`
  This method is now obsolete, please use a combination of `getActionMap()` and `getInputMap()` for similar behavior.
  `void`
  `removeAncestorListener(AncestorListener listener)`
  Unregisters `listener` so that it will no longer receive `AncestorEvents`.
  `void`
  `removeNotify()`
  Notifies this component that it no longer has a parent component.
  `void`
  `removeVetoableChangeListener(VetoableChangeListener listener)`
  Removes a `VetoableChangeListener` from the listener list.
  `void`
  `repaint(long tm, int x, int y, int width, int height)`
  Adds the specified region to the dirty region list if the component is showing.
  `void`
  `repaint(Rectangle r)`
  Adds the specified region to the dirty region list if the component is showing.
  `boolean`
  `requestDefaultFocus()`
  Deprecated.
  As of 1.4, replaced by `FocusTraversalPolicy.getDefaultComponent(Container).requestFocus()`
  `void`
  `requestFocus()`
  Requests that this `Component` gets the input focus.
  `boolean`
  `requestFocus(boolean temporary)`
  Requests that this `Component` gets the input focus.
  `boolean`
  `requestFocusInWindow()`
  Requests that this `Component` gets the input focus.
  `protected boolean`
  `requestFocusInWindow(boolean temporary)`
  Requests that this `Component` gets the input focus.
  `void`
  `resetKeyboardActions()`
  Unregisters all the bindings in the first tier `InputMaps` and `ActionMap`.
  `void`
  `reshape(int x, int y, int w, int h)`
  Deprecated.
  As of JDK 5, replaced by `Component.setBounds(int, int, int, int)`.
  `void`
  `revalidate()`
  Supports deferred automatic layout.
  `void`
  `scrollRectToVisible(Rectangle aRect)`
  Forwards the `scrollRectToVisible()` message to the `JComponent`'s parent.
  `final void`
  `setActionMap(ActionMap am)`
  Sets the `ActionMap` to `am`.
  `void`
  `setAlignmentX(float alignmentX)`
  Sets the horizontal alignment.
  `void`
  `setAlignmentY(float alignmentY)`
  Sets the vertical alignment.
  `void`
  `setAutoscrolls(boolean autoscrolls)`
  Sets the `autoscrolls` property.
  `void`
  `setBackground(Color bg)`
  Sets the background color of this component.
  `void`
  `setBorder(Border border)`
  Sets the border of this component.
  `void`
  `setComponentPopupMenu(JPopupMenu popup)`
  Sets the `JPopupMenu` for this `JComponent`.
  `void`
  `setDebugGraphicsOptions(int debugOptions)`
  Enables or disables diagnostic information about every graphics operation performed within the component or one of its children.
  `static void`
  `setDefaultLocale(Locale l)`
  Sets the default locale used to initialize each JComponent's locale property upon creation.
  `void`
  `setDoubleBuffered(boolean aFlag)`
  Sets whether this component should use a buffer to paint.
  `void`
  `setEnabled(boolean enabled)`
  Sets whether or not this component is enabled.
  `void`
  `setFocusTraversalKeys(int id, Set<? extends AWTKeyStroke> keystrokes)`
  Sets the focus traversal keys for a given traversal operation for this Component.
  `void`
  `setFont(Font font)`
  Sets the font for this component.
  `void`
  `setForeground(Color fg)`
  Sets the foreground color of this component.
  `void`
  `setInheritsPopupMenu(boolean value)`
  Sets whether or not `getComponentPopupMenu` should delegate to the parent if this component does not have a `JPopupMenu` assigned to it.
  `final void`
  `setInputMap(int condition, InputMap map)`
  Sets the `InputMap` to use under the condition `condition` to `map`.
  `void`
  `setInputVerifier(InputVerifier inputVerifier)`
  Sets the input verifier for this component.
  `void`
  `setMaximumSize(Dimension maximumSize)`
  Sets the maximum size of this component to a constant value.
  `void`
  `setMinimumSize(Dimension minimumSize)`
  Sets the minimum size of this component to a constant value.
  `void`
  `setNextFocusableComponent(Component aComponent)`
  Deprecated.
  As of 1.4, replaced by `FocusTraversalPolicy`
  `void`
  `setOpaque(boolean isOpaque)`
  If true the component paints every pixel within its bounds.
  `void`
  `setPreferredSize(Dimension preferredSize)`
  Sets the preferred size of this component.
  `void`
  `setRequestFocusEnabled(boolean requestFocusEnabled)`
  Provides a hint as to whether or not this `JComponent` should get focus.
  `void`
  `setToolTipText(String text)`
  Registers the text to display in a tool tip.
  `void`
  `setTransferHandler(TransferHandler newHandler)`
  Sets the `TransferHandler`, which provides support for transfer of data into and out of this component via cut/copy/paste and drag and drop.
  `protected void`
  `setUI(ComponentUI newUI)`
  Sets the look and feel delegate for this component.
  `void`
  `setVerifyInputWhenFocusTarget(boolean verifyInputWhenFocusTarget)`
  Sets the value to indicate whether input verifier for the current focus owner will be called before this component requests focus.
  `void`
  `setVisible(boolean aFlag)`
  Makes the component visible or invisible.
  `void`
  `unregisterKeyboardAction(KeyStroke aKeyStroke)`
  This method is now obsolete.
  `void`
  `update(Graphics g)`
  Calls `paint`.

  ### Methods declared in class Container

  `addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`
  Modifier and Type
  Method
  Description
  `void`
  `addContainerListener(ContainerListener l)`
  Adds the specified container listener to receive container events from this container.
  `protected void`
  `addImpl(Component comp, Object constraints, int index)`
  Adds the specified component to this container at the specified index.
  `void`
  `addPropertyChangeListener(PropertyChangeListener listener)`
  Adds a PropertyChangeListener to the listener list.
  `void`
  `addPropertyChangeListener(String propertyName, PropertyChangeListener listener)`
  Adds a PropertyChangeListener to the listener list for a specific property.
  `void`
  `applyComponentOrientation(ComponentOrientation o)`
  Sets the `ComponentOrientation` property of this container and all components contained within it.
  `boolean`
  `areFocusTraversalKeysSet(int id)`
  Returns whether the Set of focus traversal keys for the given focus traversal operation has been explicitly defined for this Container.
  `int`
  `countComponents()`
  Deprecated.
  As of JDK version 1.1, replaced by getComponentCount().
  `void`
  `deliverEvent(Event e)`
  Deprecated.
  As of JDK version 1.1, replaced by `dispatchEvent(AWTEvent e)`
  `void`
  `doLayout()`
  Causes this container to lay out its components.
  `Component`
  `findComponentAt(int x, int y)`
  Locates the visible child component that contains the specified position.
  `Component`
  `findComponentAt(Point p)`
  Locates the visible child component that contains the specified point.
  `Component`
  `getComponent(int n)`
  Gets the nth component in this container.
  `Component`
  `getComponentAt(int x, int y)`
  Locates the component that contains the x,y position.
  `Component`
  `getComponentAt(Point p)`
  Gets the component that contains the specified point.
  `int`
  `getComponentCount()`
  Gets the number of components in this panel.
  `Component[]`
  `getComponents()`
  Gets all the components in this container.
  `int`
  `getComponentZOrder(Component comp)`
  Returns the z-order index of the component inside the container.
  `ContainerListener[]`
  `getContainerListeners()`
  Returns an array of all the container listeners registered on this container.
  `Set<AWTKeyStroke>`
  `getFocusTraversalKeys(int id)`
  Returns the Set of focus traversal keys for a given traversal operation for this Container.
  `FocusTraversalPolicy`
  `getFocusTraversalPolicy()`
  Returns the focus traversal policy that will manage keyboard traversal of this Container's children, or null if this Container is not a focus cycle root.
  `LayoutManager`
  `getLayout()`
  Gets the layout manager for this container.
  `Point`
  `getMousePosition(boolean allowChildren)`
  Returns the position of the mouse pointer in this `Container`'s coordinate space if the `Container` is under the mouse pointer, otherwise returns `null`.
  `Insets`
  `insets()`
  Deprecated.
  As of JDK version 1.1, replaced by `getInsets()`.
  `void`
  `invalidate()`
  Invalidates the container.
  `boolean`
  `isAncestorOf(Component c)`
  Checks if the component is contained in the component hierarchy of this container.
  `boolean`
  `isFocusCycleRoot()`
  Returns whether this Container is the root of a focus traversal cycle.
  `boolean`
  `isFocusCycleRoot(Container container)`
  Returns whether the specified Container is the focus cycle root of this Container's focus traversal cycle.
  `final boolean`
  `isFocusTraversalPolicyProvider()`
  Returns whether this container provides focus traversal policy.
  `boolean`
  `isFocusTraversalPolicySet()`
  Returns whether the focus traversal policy has been explicitly set for this Container.
  `void`
  `layout()`
  Deprecated.
  As of JDK version 1.1, replaced by `doLayout()`.
  `void`
  `list(PrintStream out, int indent)`
  Prints a listing of this container to the specified output stream.
  `void`
  `list(PrintWriter out, int indent)`
  Prints out a list, starting at the specified indentation, to the specified print writer.
  `Component`
  `locate(int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by `getComponentAt(int, int)`.
  `Dimension`
  `minimumSize()`
  Deprecated.
  As of JDK version 1.1, replaced by `getMinimumSize()`.
  `void`
  `paintComponents(Graphics g)`
  Paints each of the components in this container.
  `Dimension`
  `preferredSize()`
  Deprecated.
  As of JDK version 1.1, replaced by `getPreferredSize()`.
  `void`
  `printComponents(Graphics g)`
  Prints each of the components in this container.
  `protected void`
  `processContainerEvent(ContainerEvent e)`
  Processes container events occurring on this container by dispatching them to any registered ContainerListener objects.
  `protected void`
  `processEvent(AWTEvent e)`
  Processes events on this container.
  `void`
  `removeContainerListener(ContainerListener l)`
  Removes the specified container listener so it no longer receives container events from this container.
  `void`
  `setComponentZOrder(Component comp, int index)`
  Moves the specified component to the specified z-order index in the container.
  `void`
  `setFocusCycleRoot(boolean focusCycleRoot)`
  Sets whether this Container is the root of a focus traversal cycle.
  `void`
  `setFocusTraversalPolicy(FocusTraversalPolicy policy)`
  Sets the focus traversal policy that will manage keyboard traversal of this Container's children, if this Container is a focus cycle root.
  `final void`
  `setFocusTraversalPolicyProvider(boolean provider)`
  Sets whether this container will be used to provide focus traversal policy.
  `void`
  `setLayout(LayoutManager mgr)`
  Sets the layout manager for this container.
  `void`
  `transferFocusDownCycle()`
  Transfers the focus down one focus traversal cycle.
  `void`
  `validate()`
  Validates this container and all of its subcomponents.
  `protected void`
  `validateTree()`
  Recursively descends the container tree and recomputes the layout for any subtrees marked as needing it (those marked as invalid).

  ### Methods declared in class Component

  `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setMixingCutoutShape, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`
  Modifier and Type
  Method
  Description
  `boolean`
  `action(Event evt, Object what)`
  Deprecated.
  As of JDK version 1.1, should register this component as ActionListener on component which fires action events.
  `void`
  `add(PopupMenu popup)`
  Adds the specified popup menu to the component.
  `void`
  `addComponentListener(ComponentListener l)`
  Adds the specified component listener to receive component events from this component.
  `void`
  `addFocusListener(FocusListener l)`
  Adds the specified focus listener to receive focus events from this component when this component gains input focus.
  `void`
  `addHierarchyBoundsListener(HierarchyBoundsListener l)`
  Adds the specified hierarchy bounds listener to receive hierarchy bounds events from this component when the hierarchy to which this container belongs changes.
  `void`
  `addHierarchyListener(HierarchyListener l)`
  Adds the specified hierarchy listener to receive hierarchy changed events from this component when the hierarchy to which this container belongs changes.
  `void`
  `addInputMethodListener(InputMethodListener l)`
  Adds the specified input method listener to receive input method events from this component.
  `void`
  `addKeyListener(KeyListener l)`
  Adds the specified key listener to receive key events from this component.
  `void`
  `addMouseListener(MouseListener l)`
  Adds the specified mouse listener to receive mouse events from this component.
  `void`
  `addMouseMotionListener(MouseMotionListener l)`
  Adds the specified mouse motion listener to receive mouse motion events from this component.
  `void`
  `addMouseWheelListener(MouseWheelListener l)`
  Adds the specified mouse wheel listener to receive mouse wheel events from this component.
  `Rectangle`
  `bounds()`
  Deprecated.
  As of JDK version 1.1, replaced by `getBounds()`.
  `int`
  `checkImage(Image image, int width, int height, ImageObserver observer)`
  Returns the status of the construction of a screen representation of the specified image.
  `int`
  `checkImage(Image image, ImageObserver observer)`
  Returns the status of the construction of a screen representation of the specified image.
  `protected AWTEvent`
  `coalesceEvents(AWTEvent existingEvent, AWTEvent newEvent)`
  Potentially coalesce an event being posted with an existing event.
  `boolean`
  `contains(Point p)`
  Checks whether this component "contains" the specified point, where the point's x and y coordinates are defined to be relative to the coordinate system of this component.
  `Image`
  `createImage(int width, int height)`
  Creates an off-screen drawable image to be used for double buffering.
  `Image`
  `createImage(ImageProducer producer)`
  Creates an image from the specified image producer.
  `VolatileImage`
  `createVolatileImage(int width, int height)`
  Creates a volatile off-screen drawable image to be used for double buffering.
  `VolatileImage`
  `createVolatileImage(int width, int height, ImageCapabilities caps)`
  Creates a volatile off-screen drawable image, with the given capabilities.
  `protected final void`
  `disableEvents(long eventsToDisable)`
  Disables the events defined by the specified event mask parameter from being delivered to this component.
  `final void`
  `dispatchEvent(AWTEvent e)`
  Dispatches an event to this component or one of its sub components.
  `void`
  `enable(boolean b)`
  Deprecated.
  As of JDK version 1.1, replaced by `setEnabled(boolean)`.
  `protected final void`
  `enableEvents(long eventsToEnable)`
  Enables the events defined by the specified event mask parameter to be delivered to this component.
  `void`
  `enableInputMethods(boolean enable)`
  Enables or disables input method support for this component.
  `void`
  `firePropertyChange(String propertyName, byte oldValue, byte newValue)`
  Reports a bound property change.
  `void`
  `firePropertyChange(String propertyName, char oldValue, char newValue)`
  Reports a bound property change.
  `void`
  `firePropertyChange(String propertyName, double oldValue, double newValue)`
  Reports a bound property change.
  `void`
  `firePropertyChange(String propertyName, float oldValue, float newValue)`
  Reports a bound property change.
  `void`
  `firePropertyChange(String propertyName, long oldValue, long newValue)`
  Reports a bound property change.
  `void`
  `firePropertyChange(String propertyName, short oldValue, short newValue)`
  Reports a bound property change.
  `protected void`
  `firePropertyChange(String propertyName, Object oldValue, Object newValue)`
  Support for reporting bound property changes for Object properties.
  `Color`
  `getBackground()`
  Gets the background color of this component.
  `Rectangle`
  `getBounds()`
  Gets the bounds of this component in the form of a `Rectangle` object.
  `ColorModel`
  `getColorModel()`
  Gets the instance of `ColorModel` used to display the component on the output device.
  `ComponentListener[]`
  `getComponentListeners()`
  Returns an array of all the component listeners registered on this component.
  `ComponentOrientation`
  `getComponentOrientation()`
  Retrieves the language-sensitive orientation that is to be used to order the elements or text within this component.
  `Cursor`
  `getCursor()`
  Gets the cursor set in the component.
  `DropTarget`
  `getDropTarget()`
  Gets the `DropTarget` associated with this `Component`.
  `Container`
  `getFocusCycleRootAncestor()`
  Returns the Container which is the focus cycle root of this Component's focus traversal cycle.
  `FocusListener[]`
  `getFocusListeners()`
  Returns an array of all the focus listeners registered on this component.
  `boolean`
  `getFocusTraversalKeysEnabled()`
  Returns whether focus traversal keys are enabled for this Component.
  `Font`
  `getFont()`
  Gets the font of this component.
  `Color`
  `getForeground()`
  Gets the foreground color of this component.
  `GraphicsConfiguration`
  `getGraphicsConfiguration()`
  Gets the `GraphicsConfiguration` associated with this `Component`.
  `HierarchyBoundsListener[]`
  `getHierarchyBoundsListeners()`
  Returns an array of all the hierarchy bounds listeners registered on this component.
  `HierarchyListener[]`
  `getHierarchyListeners()`
  Returns an array of all the hierarchy listeners registered on this component.
  `boolean`
  `getIgnoreRepaint()`
  Returns whether or not paint messages received from the operating system should be ignored.
  `InputContext`
  `getInputContext()`
  Gets the input context used by this component for handling the communication with input methods when text is entered in this component.
  `InputMethodListener[]`
  `getInputMethodListeners()`
  Returns an array of all the input method listeners registered on this component.
  `InputMethodRequests`
  `getInputMethodRequests()`
  Gets the input method request handler which supports requests from input methods for this component.
  `KeyListener[]`
  `getKeyListeners()`
  Returns an array of all the key listeners registered on this component.
  `Locale`
  `getLocale()`
  Gets the locale of this component.
  `Point`
  `getLocation()`
  Gets the location of this component in the form of a point specifying the component's top-left corner.
  `Point`
  `getLocationOnScreen()`
  Gets the location of this component in the form of a point specifying the component's top-left corner in the screen's coordinate space.
  `MouseListener[]`
  `getMouseListeners()`
  Returns an array of all the mouse listeners registered on this component.
  `MouseMotionListener[]`
  `getMouseMotionListeners()`
  Returns an array of all the mouse motion listeners registered on this component.
  `Point`
  `getMousePosition()`
  Returns the position of the mouse pointer in this `Component`'s coordinate space if the `Component` is directly under the mouse pointer, otherwise returns `null`.
  `MouseWheelListener[]`
  `getMouseWheelListeners()`
  Returns an array of all the mouse wheel listeners registered on this component.
  `String`
  `getName()`
  Gets the name of the component.
  `Container`
  `getParent()`
  Gets the parent of this component.
  `PropertyChangeListener[]`
  `getPropertyChangeListeners()`
  Returns an array of all the property change listeners registered on this component.
  `PropertyChangeListener[]`
  `getPropertyChangeListeners(String propertyName)`
  Returns an array of all the listeners which have been associated with the named property.
  `Dimension`
  `getSize()`
  Returns the size of this component in the form of a `Dimension` object.
  `Toolkit`
  `getToolkit()`
  Gets the toolkit of this component.
  `final Object`
  `getTreeLock()`
  Gets this component's locking object (the object that owns the thread synchronization monitor) for AWT component-tree and layout operations.
  `boolean`
  `gotFocus(Event evt, Object what)`
  Deprecated.
  As of JDK version 1.1, replaced by processFocusEvent(FocusEvent).
  `boolean`
  `handleEvent(Event evt)`
  Deprecated.
  As of JDK version 1.1 replaced by processEvent(AWTEvent).
  `boolean`
  `hasFocus()`
  Returns `true` if this `Component` is the focus owner.
  `boolean`
  `imageUpdate(Image img, int infoflags, int x, int y, int w, int h)`
  Repaints the component when the image has changed.
  `boolean`
  `inside(int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by contains(int, int).
  `boolean`
  `isBackgroundSet()`
  Returns whether the background color has been explicitly set for this Component.
  `boolean`
  `isCursorSet()`
  Returns whether the cursor has been explicitly set for this Component.
  `boolean`
  `isDisplayable()`
  Determines whether this component is displayable.
  `boolean`
  `isEnabled()`
  Determines whether this component is enabled.
  `boolean`
  `isFocusable()`
  Returns whether this Component can be focused.
  `boolean`
  `isFocusOwner()`
  Returns `true` if this `Component` is the focus owner.
  `boolean`
  `isFocusTraversable()`
  Deprecated.
  As of 1.4, replaced by `isFocusable()`.
  `boolean`
  `isFontSet()`
  Returns whether the font has been explicitly set for this Component.
  `boolean`
  `isForegroundSet()`
  Returns whether the foreground color has been explicitly set for this Component.
  `boolean`
  `isLightweight()`
  A lightweight component doesn't have a native toolkit peer.
  `boolean`
  `isMaximumSizeSet()`
  Returns true if the maximum size has been set to a non-`null` value otherwise returns false.
  `boolean`
  `isMinimumSizeSet()`
  Returns whether or not `setMinimumSize` has been invoked with a non-null value.
  `boolean`
  `isPreferredSizeSet()`
  Returns true if the preferred size has been set to a non-`null` value otherwise returns false.
  `boolean`
  `isShowing()`
  Determines whether this component is showing on screen.
  `boolean`
  `isValid()`
  Determines whether this component is valid.
  `boolean`
  `isVisible()`
  Determines whether this component should be visible when its parent is visible.
  `boolean`
  `keyDown(Event evt, int key)`
  Deprecated.
  As of JDK version 1.1, replaced by processKeyEvent(KeyEvent).
  `boolean`
  `keyUp(Event evt, int key)`
  Deprecated.
  As of JDK version 1.1, replaced by processKeyEvent(KeyEvent).
  `void`
  `list()`
  Prints a listing of this component to the standard system output stream `System.out`.
  `void`
  `list(PrintStream out)`
  Prints a listing of this component to the specified output stream.
  `void`
  `list(PrintWriter out)`
  Prints a listing to the specified print writer.
  `Point`
  `location()`
  Deprecated.
  As of JDK version 1.1, replaced by `getLocation()`.
  `boolean`
  `lostFocus(Event evt, Object what)`
  Deprecated.
  As of JDK version 1.1, replaced by processFocusEvent(FocusEvent).
  `boolean`
  `mouseDown(Event evt, int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
  `boolean`
  `mouseDrag(Event evt, int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by processMouseMotionEvent(MouseEvent).
  `boolean`
  `mouseEnter(Event evt, int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
  `boolean`
  `mouseExit(Event evt, int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
  `boolean`
  `mouseMove(Event evt, int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by processMouseMotionEvent(MouseEvent).
  `boolean`
  `mouseUp(Event evt, int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
  `void`
  `move(int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by `setLocation(int, int)`.
  `void`
  `nextFocus()`
  Deprecated.
  As of JDK version 1.1, replaced by transferFocus().
  `void`
  `paintAll(Graphics g)`
  Paints this component and all of its subcomponents.
  `boolean`
  `postEvent(Event e)`
  Deprecated.
  As of JDK version 1.1, replaced by dispatchEvent(AWTEvent).
  `boolean`
  `prepareImage(Image image, int width, int height, ImageObserver observer)`
  Prepares an image for rendering on this component at the specified width and height.
  `boolean`
  `prepareImage(Image image, ImageObserver observer)`
  Prepares an image for rendering on this component.
  `protected void`
  `processComponentEvent(ComponentEvent e)`
  Processes component events occurring on this component by dispatching them to any registered `ComponentListener` objects.
  `protected void`
  `processFocusEvent(FocusEvent e)`
  Processes focus events occurring on this component by dispatching them to any registered `FocusListener` objects.
  `protected void`
  `processHierarchyBoundsEvent(HierarchyEvent e)`
  Processes hierarchy bounds events occurring on this component by dispatching them to any registered `HierarchyBoundsListener` objects.
  `protected void`
  `processHierarchyEvent(HierarchyEvent e)`
  Processes hierarchy events occurring on this component by dispatching them to any registered `HierarchyListener` objects.
  `protected void`
  `processInputMethodEvent(InputMethodEvent e)`
  Processes input method events occurring on this component by dispatching them to any registered `InputMethodListener` objects.
  `protected void`
  `processMouseWheelEvent(MouseWheelEvent e)`
  Processes mouse wheel events occurring on this component by dispatching them to any registered `MouseWheelListener` objects.
  `void`
  `remove(MenuComponent popup)`
  Removes the specified popup menu from the component.
  `void`
  `removeComponentListener(ComponentListener l)`
  Removes the specified component listener so that it no longer receives component events from this component.
  `void`
  `removeFocusListener(FocusListener l)`
  Removes the specified focus listener so that it no longer receives focus events from this component.
  `void`
  `removeHierarchyBoundsListener(HierarchyBoundsListener l)`
  Removes the specified hierarchy bounds listener so that it no longer receives hierarchy bounds events from this component.
  `void`
  `removeHierarchyListener(HierarchyListener l)`
  Removes the specified hierarchy listener so that it no longer receives hierarchy changed events from this component.
  `void`
  `removeInputMethodListener(InputMethodListener l)`
  Removes the specified input method listener so that it no longer receives input method events from this component.
  `void`
  `removeKeyListener(KeyListener l)`
  Removes the specified key listener so that it no longer receives key events from this component.
  `void`
  `removeMouseListener(MouseListener l)`
  Removes the specified mouse listener so that it no longer receives mouse events from this component.
  `void`
  `removeMouseMotionListener(MouseMotionListener l)`
  Removes the specified mouse motion listener so that it no longer receives mouse motion events from this component.
  `void`
  `removeMouseWheelListener(MouseWheelListener l)`
  Removes the specified mouse wheel listener so that it no longer receives mouse wheel events from this component.
  `void`
  `removePropertyChangeListener(PropertyChangeListener listener)`
  Removes a PropertyChangeListener from the listener list.
  `void`
  `removePropertyChangeListener(String propertyName, PropertyChangeListener listener)`
  Removes a `PropertyChangeListener` from the listener list for a specific property.
  `void`
  `repaint()`
  Repaints this component.
  `void`
  `repaint(int x, int y, int width, int height)`
  Repaints the specified rectangle of this component.
  `void`
  `repaint(long tm)`
  Repaints the component.
  `protected boolean`
  `requestFocus(boolean temporary, FocusEvent.Cause cause)`
  Requests by the reason of `cause` that this `Component` get the input focus, and that this `Component`'s top-level ancestor become the focused `Window`.
  `void`
  `requestFocus(FocusEvent.Cause cause)`
  Requests by the reason of `cause` that this Component get the input focus, and that this Component's top-level ancestor become the focused Window.
  `boolean`
  `requestFocusInWindow(FocusEvent.Cause cause)`
  Requests by the reason of `cause` that this Component get the input focus, if this Component's top-level ancestor is already the focused Window.
  `void`
  `resize(int width, int height)`
  Deprecated.
  As of JDK version 1.1, replaced by `setSize(int, int)`.
  `void`
  `resize(Dimension d)`
  Deprecated.
  As of JDK version 1.1, replaced by `setSize(Dimension)`.
  `void`
  `setBounds(int x, int y, int width, int height)`
  Moves and resizes this component.
  `void`
  `setBounds(Rectangle r)`
  Moves and resizes this component to conform to the new bounding rectangle `r`.
  `void`
  `setComponentOrientation(ComponentOrientation o)`
  Sets the language-sensitive orientation that is to be used to order the elements or text within this component.
  `void`
  `setCursor(Cursor cursor)`
  Sets the cursor image to the specified cursor.
  `void`
  `setDropTarget(DropTarget dt)`
  Associate a `DropTarget` with this component.
  `void`
  `setFocusable(boolean focusable)`
  Sets the focusable state of this Component to the specified value.
  `void`
  `setFocusTraversalKeysEnabled(boolean focusTraversalKeysEnabled)`
  Sets whether focus traversal keys are enabled for this Component.
  `void`
  `setIgnoreRepaint(boolean ignoreRepaint)`
  Sets whether or not paint messages received from the operating system should be ignored.
  `void`
  `setLocale(Locale l)`
  Sets the locale of this component.
  `void`
  `setLocation(int x, int y)`
  Moves this component to a new location.
  `void`
  `setLocation(Point p)`
  Moves this component to a new location.
  `void`
  `setMixingCutoutShape(Shape shape)`
  Sets a 'mixing-cutout' shape for this lightweight component.
  `void`
  `setName(String name)`
  Sets the name of the component to the specified string.
  `void`
  `setSize(int width, int height)`
  Resizes this component so that it has width `width` and height `height`.
  `void`
  `setSize(Dimension d)`
  Resizes this component so that it has width `d.width` and height `d.height`.
  `void`
  `show()`
  Deprecated.
  As of JDK version 1.1, replaced by `setVisible(boolean)`.
  `void`
  `show(boolean b)`
  Deprecated.
  As of JDK version 1.1, replaced by `setVisible(boolean)`.
  `Dimension`
  `size()`
  Deprecated.
  As of JDK version 1.1, replaced by `getSize()`.
  `String`
  `toString()`
  Returns a string representation of this component and its values.
  `void`
  `transferFocus()`
  Transfers the focus to the next component, as though this Component were the focus owner.
  `void`
  `transferFocusBackward()`
  Transfers the focus to the previous component, as though this Component were the focus owner.
  `void`
  `transferFocusUpCycle()`
  Transfers the focus up one focus traversal cycle.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Field Details

  - ### WRAP_TAB_LAYOUT

    public static final int WRAP_TAB_LAYOUT
    The tab layout policy for wrapping tabs in multiple runs when all tabs will not fit within a single run.
    See Also:
      - Constant Field Values

  - ### SCROLL_TAB_LAYOUT

    public static final int SCROLL_TAB_LAYOUT
    Tab layout policy for providing a subset of available tabs when all the tabs will not fit within a single run. If all the tabs do not fit within a single run the look and feel will provide a way to navigate to hidden tabs.
    See Also:
      - Constant Field Values

  - ### tabPlacement

    protected int tabPlacement
    Where the tabs are placed.
    See Also:
      - `setTabPlacement(int)`

  - ### model

    protected SingleSelectionModel model
    The default selection model

  - ### changeListener

    protected ChangeListener changeListener
    The `changeListener` is the listener we add to the model.

  - ### changeEvent

    protected transient ChangeEvent changeEvent
    Only one `ChangeEvent` is needed per `TabPane` instance since the event's only (read-only) state is the source property. The source of events generated here is always "this".

- ## Constructor Details

  - ### JTabbedPane

    public JTabbedPane()
    Creates an empty `TabbedPane` with a default tab placement of `JTabbedPane.TOP`.
    See Also:
      - `addTab(String, Icon, Component, String)`

  - ### JTabbedPane

    public JTabbedPane(int tabPlacement)
    Creates an empty `TabbedPane` with the specified tab placement of either: `JTabbedPane.TOP`, `JTabbedPane.BOTTOM`, `JTabbedPane.LEFT`, or `JTabbedPane.RIGHT`.
    Parameters:
      `tabPlacement` - the placement for the tabs relative to the content
    See Also:
      - `addTab(String, Icon, Component, String)`

  - ### JTabbedPane

    public JTabbedPane(int tabPlacement, int tabLayoutPolicy)
    Creates an empty `TabbedPane` with the specified tab placement and tab layout policy. Tab placement may be either: `JTabbedPane.TOP`, `JTabbedPane.BOTTOM`, `JTabbedPane.LEFT`, or `JTabbedPane.RIGHT`. Tab layout policy may be either: `JTabbedPane.WRAP_TAB_LAYOUT` or `JTabbedPane.SCROLL_TAB_LAYOUT`.
    Parameters:
      `tabPlacement` - the placement for the tabs relative to the content
      `tabLayoutPolicy` - the policy for laying out tabs when all tabs will not fit on one run
    Throws:
      `IllegalArgumentException` - if tab placement or tab layout policy are not one of the above supported values
    Since:
      1.4
    See Also:
      - `addTab(String, Icon, Component, String)`

- ## Method Details

  - ### getUI

    public TabbedPaneUI getUI()
    Returns the UI object which implements the L&F for this component.
    Overrides:
      `getUI` in class `JComponent`
    Returns:
      a `TabbedPaneUI` object
    See Also:
      - `setUI(TabbedPaneUI)`

  - ### setUI

    @BeanProperty(hidden=true, visualUpdate=true, description="The UI object that implements the tabbedpane's LookAndFeel") public void setUI(TabbedPaneUI ui)
    Sets the UI object which implements the L&F for this component.
    Parameters:
      `ui` - the new UI object
    See Also:
      - `UIDefaults.getUI(JComponent)`

  - ### updateUI

    public void updateUI()
    Resets the UI property to a value from the current look and feel.
    Overrides:
      `updateUI` in class `JComponent`
    See Also:
      - `JComponent.updateUI()`

  - ### getUIClassID

    @BeanProperty(bound=false) public String getUIClassID()
    Returns the name of the UI class that implements the L&F for this component.
    Overrides:
      `getUIClassID` in class `JComponent`
    Returns:
      the string "TabbedPaneUI"
    See Also:
      - `JComponent.getUIClassID()`
      - `UIDefaults.getUI(JComponent)`

  - ### createChangeListener

    protected ChangeListener createChangeListener()
    Subclasses that want to handle `ChangeEvents` differently can override this to return a subclass of `ModelListener` or another `ChangeListener` implementation.
    Returns:
      a `ChangeListener`
    See Also:
      - `fireStateChanged()`

  - ### addChangeListener

    public void addChangeListener(ChangeListener l)
    Adds a `ChangeListener` to this tabbedpane.
    Parameters:
      `l` - the `ChangeListener` to add
    See Also:
      - `fireStateChanged()`
      - `removeChangeListener(ChangeListener)`

  - ### removeChangeListener

    public void removeChangeListener(ChangeListener l)
    Removes a `ChangeListener` from this tabbedpane.
    Parameters:
      `l` - the `ChangeListener` to remove
    See Also:
      - `fireStateChanged()`
      - `addChangeListener(ChangeListener)`

  - ### getChangeListeners

    @BeanProperty(bound=false) public ChangeListener[] getChangeListeners()
    Returns an array of all the `ChangeListener`s added to this `JTabbedPane` with `addChangeListener`.
    Returns:
      all of the `ChangeListener`s added or an empty array if no listeners have been added
    Since:
      1.4

  - ### fireStateChanged

    protected void fireStateChanged()
    Sends a `ChangeEvent`, with this `JTabbedPane` as the source, to each registered listener. This method is called each time there is a change to either the selected index or the selected tab in the `JTabbedPane`. Usually, the selected index and selected tab change together. However, there are some cases, such as tab addition, where the selected index changes and the same tab remains selected. There are other cases, such as deleting the selected tab, where the index remains the same, but a new tab moves to that index. Events are fired for all of these cases.
    See Also:
      - `addChangeListener(ChangeListener)`
      - `EventListenerList`

  - ### getModel

    public SingleSelectionModel getModel()
    Returns the model associated with this tabbedpane.
    Returns:
      the `SingleSelectionModel` associated with this tabbedpane
    See Also:
      - `setModel(SingleSelectionModel)`

  - ### setModel

    @BeanProperty(description="The tabbedpane's SingleSelectionModel.") public void setModel(SingleSelectionModel model)
    Sets the model to be used with this tabbedpane.
    Parameters:
      `model` - the model to be used
    See Also:
      - `getModel()`

  - ### getTabPlacement

    public int getTabPlacement()
    Returns the placement of the tabs for this tabbedpane.
    Returns:
      an `int` specifying the placement for the tabs
    See Also:
      - `setTabPlacement(int)`

  - ### setTabPlacement

    @BeanProperty(preferred=true, visualUpdate=true, enumerationValues={"JTabbedPane.TOP","JTabbedPane.LEFT","JTabbedPane.BOTTOM","JTabbedPane.RIGHT"}, description="The tabbedpane's tab placement.") public void setTabPlacement(int tabPlacement)
    Sets the tab placement for this tabbedpane. Possible values are:
    - `JTabbedPane.TOP`
    - `JTabbedPane.BOTTOM`
    - `JTabbedPane.LEFT`
    - `JTabbedPane.RIGHT`
    The default value, if not set, is `SwingConstants.TOP`.
    Parameters:
      `tabPlacement` - the placement for the tabs relative to the content
    Throws:
      `IllegalArgumentException` - if tab placement value isn't one of the above valid values

  - ### getTabLayoutPolicy

    public int getTabLayoutPolicy()
    Returns the policy used by the tabbedpane to layout the tabs when all the tabs will not fit within a single run.
    Returns:
      an `int` specifying the policy used to layout the tabs
    Since:
      1.4
    See Also:
      - `setTabLayoutPolicy(int)`

  - ### setTabLayoutPolicy

    @BeanProperty(preferred=true, visualUpdate=true, enumerationValues={"JTabbedPane.WRAP_TAB_LAYOUT","JTabbedPane.SCROLL_TAB_LAYOUT"}, description="The tabbedpane's policy for laying out the tabs") public void setTabLayoutPolicy(int tabLayoutPolicy)
    Sets the policy which the tabbedpane will use in laying out the tabs when all the tabs will not fit within a single run. Possible values are:
    - `JTabbedPane.WRAP_TAB_LAYOUT`
    - `JTabbedPane.SCROLL_TAB_LAYOUT`
    The default value, if not set by the UI, is `JTabbedPane.WRAP_TAB_LAYOUT`.

    Some look and feels might only support a subset of the possible layout policies, in which case the value of this property may be ignored.

    Parameters:
      `tabLayoutPolicy` - the policy used to layout the tabs
    Throws:
      `IllegalArgumentException` - if layoutPolicy value isn't one of the above valid values
    Since:
      1.4
    See Also:
      - `getTabLayoutPolicy()`

  - ### getSelectedIndex

    public int getSelectedIndex()
    Returns the currently selected index for this tabbedpane. Returns -1 if there is no currently selected tab.
    Returns:
      the index of the selected tab
    See Also:
      - `setSelectedIndex(int)`

  - ### setSelectedIndex

    @BeanProperty(bound=false, preferred=true, description="The tabbedpane's selected tab index.") public void setSelectedIndex(int index)
    Sets the selected index for this tabbedpane. The index must be a valid tab index or -1, which indicates that no tab should be selected (can also be used when there are no tabs in the tabbedpane). If a -1 value is specified when the tabbedpane contains one or more tabs, then the results will be implementation defined.
    Parameters:
      `index` - the index to be selected
    Throws:
      `IndexOutOfBoundsException` - if index is out of range `(index < -1 || index >= tab count)`
    See Also:
      - `getSelectedIndex()`
      - `SingleSelectionModel.setSelectedIndex(int)`

  - ### getSelectedComponent

    public Component getSelectedComponent()
    Returns the currently selected component for this tabbedpane. Returns `null` if there is no currently selected tab.
    Returns:
      the component corresponding to the selected tab
    See Also:
      - `setSelectedComponent(Component)`

  - ### setSelectedComponent

    @BeanProperty(bound=false, preferred=true, description="The tabbedpane's selected component.") public void setSelectedComponent(Component c)
    Sets the selected component for this tabbedpane. This will automatically set the `selectedIndex` to the index corresponding to the specified component.
    Parameters:
      `c` - the selected `Component` for this `TabbedPane`
    Throws:
      `IllegalArgumentException` - if component not found in tabbed pane
    See Also:
      - `getSelectedComponent()`

  - ### insertTab

    public void insertTab(String title, Icon icon, Component component, String tip, int index)
    Inserts a new tab for the given component, at the given index, represented by the given title and/or icon, either of which may be `null`.
    Parameters:
      `title` - the title to be displayed on the tab
      `icon` - the icon to be displayed on the tab
      `component` - the component to be displayed when this tab is clicked.
      `tip` - the tooltip to be displayed for this tab
      `index` - the position to insert this new tab `(index >= 0 && index <= getTabCount())`
    Throws:
      `IndexOutOfBoundsException` - if the index is out of range `(index < 0 || index > getTabCount())`
    See Also:
      - `addTab(String, Icon, Component, String)`
      - `removeTabAt(int)`

  - ### addTab

    public void addTab(String title, Icon icon, Component component, String tip)
    Adds a `component` and `tip` represented by a `title` and/or `icon`, either of which can be `null`. Cover method for `insertTab`.
    Parameters:
      `title` - the title to be displayed in this tab
      `icon` - the icon to be displayed in this tab
      `component` - the component to be displayed when this tab is clicked
      `tip` - the tooltip to be displayed for this tab
    See Also:
      - `insertTab(String, Icon, Component, String, int)`
      - `removeTabAt(int)`

  - ### addTab

    public void addTab(String title, Icon icon, Component component)
    Adds a `component` represented by a `title` and/or `icon`, either of which can be `null`. Cover method for `insertTab`.
    Parameters:
      `title` - the title to be displayed in this tab
      `icon` - the icon to be displayed in this tab
      `component` - the component to be displayed when this tab is clicked
    See Also:
      - `insertTab(String, Icon, Component, String, int)`
      - `removeTabAt(int)`

  - ### addTab

    public void addTab(String title, Component component)
    Adds a `component` represented by a `title` and no icon. Cover method for `insertTab`.
    Parameters:
      `title` - the title to be displayed in this tab
      `component` - the component to be displayed when this tab is clicked
    See Also:
      - `insertTab(String, Icon, Component, String, int)`
      - `removeTabAt(int)`

  - ### add

    public Component add(Component component)
    Adds a `component` with a tab title defaulting to the name of the component which is the result of calling `component.getName`. Cover method for `insertTab`.
    Overrides:
      `add` in class `Container`
    Parameters:
      `component` - the component to be displayed when this tab is clicked
    Returns:
      the component
    See Also:
      - `insertTab(String, Icon, Component, String, int)`
      - `removeTabAt(int)`

  - ### add

    public Component add(String title, Component component)
    Adds a `component` with the specified tab title. Cover method for `insertTab`.
    Overrides:
      `add` in class `Container`
    Parameters:
      `title` - the title to be displayed in this tab
      `component` - the component to be displayed when this tab is clicked
    Returns:
      the component
    See Also:
      - `insertTab(String, Icon, Component, String, int)`
      - `removeTabAt(int)`

  - ### add

    public Component add(Component component, int index)
    Adds a `component` at the specified tab index with a tab title defaulting to the name of the component. Cover method for `insertTab`.
    Overrides:
      `add` in class `Container`
    Parameters:
      `component` - the component to be displayed when this tab is clicked
      `index` - the position to insert this new tab
    Returns:
      the component
    See Also:
      - `insertTab(String, Icon, Component, String, int)`
      - `removeTabAt(int)`

  - ### add

    public void add(Component component, Object constraints)
    Adds a `component` to the tabbed pane. If `constraints` is a `String` or an `Icon`, it will be used for the tab title, otherwise the component's name will be used as the tab title. Cover method for `insertTab`.
    Overrides:
      `add` in class `Container`
    Parameters:
      `component` - the component to be displayed when this tab is clicked
      `constraints` - the object to be displayed in the tab
    See Also:
      - `insertTab(String, Icon, Component, String, int)`
      - `removeTabAt(int)`

  - ### add

    public void add(Component component, Object constraints, int index)
    Adds a `component` at the specified tab index. If `constraints` is a `String` or an `Icon`, it will be used for the tab title, otherwise the component's name will be used as the tab title. Cover method for `insertTab`.
    Overrides:
      `add` in class `Container`
    Parameters:
      `component` - the component to be displayed when this tab is clicked
      `constraints` - the object to be displayed in the tab
      `index` - the position to insert this new tab
    See Also:
      - `insertTab(String, Icon, Component, String, int)`
      - `removeTabAt(int)`

  - ### removeTabAt

    public void removeTabAt(int index)
    Removes the tab at `index`. After the component associated with `index` is removed, its visibility is reset to true to ensure it will be visible if added to other containers.
    Parameters:
      `index` - the index of the tab to be removed
    Throws:
      `IndexOutOfBoundsException` - if index is out of range `(index < 0 || index >= tab count)`
    See Also:
      - `addTab(String, Icon, Component, String)`
      - `insertTab(String, Icon, Component, String, int)`

  - ### remove

    public void remove(Component component)
    Removes the specified `Component` from the `JTabbedPane`. The method does nothing if the `component` is null.
    Overrides:
      `remove` in class `Container`
    Parameters:
      `component` - the component to remove from the tabbedpane
    See Also:
      - `addTab(String, Icon, Component, String)`
      - `removeTabAt(int)`

  - ### remove

    public void remove(int index)
    Removes the tab and component which corresponds to the specified index.
    Overrides:
      `remove` in class `Container`
    Parameters:
      `index` - the index of the component to remove from the `tabbedpane`
    Throws:
      `IndexOutOfBoundsException` - if index is out of range `(index < 0 || index >= tab count)`
    See Also:
      - `addTab(String, Icon, Component, String)`
      - `removeTabAt(int)`

  - ### removeAll

    public void removeAll()
    Removes all the tabs and their corresponding components from the `tabbedpane`.
    Overrides:
      `removeAll` in class `Container`
    See Also:
      - `addTab(String, Icon, Component, String)`
      - `removeTabAt(int)`

  - ### getTabCount

    @BeanProperty(bound=false) public int getTabCount()
    Returns the number of tabs in this `tabbedpane`.
    Returns:
      an integer specifying the number of tabbed pages

  - ### getTabRunCount

    @BeanProperty(bound=false) public int getTabRunCount()
    Returns the number of tab runs currently used to display the tabs.
    Returns:
      an integer giving the number of rows if the `tabPlacement` is `TOP` or `BOTTOM` and the number of columns if `tabPlacement` is `LEFT` or `RIGHT`, or 0 if there is no UI set on this `tabbedpane`

  - ### getTitleAt

    public String getTitleAt(int index)
    Returns the tab title at `index`.
    Parameters:
      `index` - the index of the item being queried
    Returns:
      the title at `index`
    Throws:
      `IndexOutOfBoundsException` - if index is out of range `(index < 0 || index >= tab count)`
    See Also:
      - `setTitleAt(int, String)`

  - ### getIconAt

    public Icon getIconAt(int index)
    Returns the tab icon at `index`.
    Parameters:
      `index` - the index of the item being queried
    Returns:
      the icon at `index`
    Throws:
      `IndexOutOfBoundsException` - if index is out of range `(index < 0 || index >= tab count)`
    See Also:
      - `setIconAt(int, Icon)`

  - ### getDisabledIconAt

    public Icon getDisabledIconAt(int index)
    Returns the tab disabled icon at `index`. If the tab disabled icon doesn't exist at `index` this will forward the call to the look and feel to construct an appropriate disabled Icon from the corresponding enabled Icon. Some look and feels might not render the disabled Icon, in which case it won't be created.
    Parameters:
      `index` - the index of the item being queried
    Returns:
      the icon at `index`
    Throws:
      `IndexOutOfBoundsException` - if index is out of range `(index < 0 || index >= tab count)`
    See Also:
      - `setDisabledIconAt(int, Icon)`

  - ### getToolTipTextAt

    public String getToolTipTextAt(int index)
    Returns the tab tooltip text at `index`.
    Parameters:
      `index` - the index of the item being queried
    Returns:
      a string containing the tool tip text at `index`
    Throws:
      `IndexOutOfBoundsException` - if index is out of range `(index < 0 || index >= tab count)`
    Since:
      1.3
    See Also:
      - `setToolTipTextAt(int, String)`

  - ### getBackgroundAt

    public Color getBackgroundAt(int index)
    Returns the tab background color at `index`.
    Parameters:
      `index` - the index of the item being queried
    Returns:
      the `Color` of the tab background at `index`
    Throws:
      `IndexOutOfBoundsException` - if index is out of range `(index < 0 || index >= tab count)`
    See Also:
      - `setBackgroundAt(int, Color)`

  - ### getForegroundAt

    public Color getForegroundAt(int index)
    Returns the tab foreground color at `index`.
    Parameters:
      `index` - the index of the item being queried
    Returns:
      the `Color` of the tab foreground at `index`
    Throws:
      `IndexOutOfBoundsException` - if index is out of range `(index < 0 || index >= tab count)`
    See Also:
      - `setForegroundAt(int, Color)`

  - ### isEnabledAt

    public boolean isEnabledAt(int index)
    Returns whether or not the tab at `index` is currently enabled.
    Parameters:
      `index` - the index of the item being queried
    Returns:
      true if the tab at `index` is enabled; false otherwise
    Throws:
      `IndexOutOfBoundsException` - if index is out of range `(index < 0 || index >= tab count)`
    See Also:
      - `setEnabledAt(int, boolean)`

  - ### getComponentAt

    public Component getComponentAt(int index)
    Returns the component at `index`.
    Parameters:
      `index` - the index of the item being queried
    Returns:
      the `Component` at `index`
    Throws:
      `IndexOutOfBoundsException` - if index is out of range `(index < 0 || index >= tab count)`
    See Also:
      - `setComponentAt(int, Component)`

  - ### getMnemonicAt

    public int getMnemonicAt(int tabIndex)
    Returns the keyboard mnemonic for accessing the specified tab. The mnemonic is the key which when combined with the look and feel's mouseless modifier (usually Alt) will activate the specified tab.
    Parameters:
      `tabIndex` - the index of the tab that the mnemonic refers to
    Returns:
      the key code which represents the mnemonic; -1 if a mnemonic is not specified for the tab
    Throws:
      `IndexOutOfBoundsException` - if index is out of range (`tabIndex` < 0 || `tabIndex` >= tab count)
    Since:
      1.4
    See Also:
      - `setDisplayedMnemonicIndexAt(int,int)`
      - `setMnemonicAt(int,int)`

  - ### getDisplayedMnemonicIndexAt

    public int getDisplayedMnemonicIndexAt(int tabIndex)
    Returns the character, as an index, that the look and feel should provide decoration for as representing the mnemonic character.
    Parameters:
      `tabIndex` - the index of the tab that the mnemonic refers to
    Returns:
      index representing mnemonic character if one exists; otherwise returns -1
    Throws:
      `IndexOutOfBoundsException` - if index is out of range (`tabIndex` < 0 || `tabIndex` >= tab count)
    Since:
      1.4
    See Also:
      - `setDisplayedMnemonicIndexAt(int,int)`
      - `setMnemonicAt(int,int)`

  - ### getBoundsAt

    public Rectangle getBoundsAt(int index)
    Returns the tab bounds at `index`. If the tab at this index is not currently visible in the UI, then returns `null`. If there is no UI set on this `tabbedpane`, then returns `null`.
    Parameters:
      `index` - the index to be queried
    Returns:
      a `Rectangle` containing the tab bounds at `index`, or `null` if tab at `index` is not currently visible in the UI, or if there is no UI set on this `tabbedpane`
    Throws:
      `IndexOutOfBoundsException` - if index is out of range `(index < 0 || index >= tab count)`

  - ### setTitleAt

    @BeanProperty(preferred=true, visualUpdate=true, description="The title at the specified tab index.") public void setTitleAt(int index, String title)
    Sets the title at `index` to `title` which can be `null`. The title is not shown if a tab component for this tab was specified. An internal exception is raised if there is no tab at that index.
    Parameters:
      `index` - the tab index where the title should be set
      `title` - the title to be displayed in the tab
    Throws:
      `IndexOutOfBoundsException` - if index is out of range `(index < 0 || index >= tab count)`
    See Also:
      - `getTitleAt(int)`
      - `setTabComponentAt(int, Component)`

  - ### setIconAt

    @BeanProperty(preferred=true, visualUpdate=true, description="The icon at the specified tab index.") public void setIconAt(int index, Icon icon)
    Sets the icon at `index` to `icon` which can be `null`. This does not set disabled icon at `icon`. If the new Icon is different than the current Icon and disabled icon is not explicitly set, the LookAndFeel will be asked to generate a disabled Icon. To explicitly set disabled icon, use `setDisableIconAt()`. The icon is not shown if a tab component for this tab was specified. An internal exception is raised if there is no tab at that index.
    Parameters:
      `index` - the tab index where the icon should be set
      `icon` - the icon to be displayed in the tab
    Throws:
      `IndexOutOfBoundsException` - if index is out of range `(index < 0 || index >= tab count)`
    See Also:
      - `setDisabledIconAt(int, Icon)`
      - `getIconAt(int)`
      - `getDisabledIconAt(int)`
      - `setTabComponentAt(int, Component)`

  - ### setDisabledIconAt

    @BeanProperty(preferred=true, visualUpdate=true, description="The disabled icon at the specified tab index.") public void setDisabledIconAt(int index, Icon disabledIcon)
    Sets the disabled icon at `index` to `icon` which can be `null`. An internal exception is raised if there is no tab at that index.
    Parameters:
      `index` - the tab index where the disabled icon should be set
      `disabledIcon` - the icon to be displayed in the tab when disabled
    Throws:
      `IndexOutOfBoundsException` - if index is out of range `(index < 0 || index >= tab count)`
    See Also:
      - `getDisabledIconAt(int)`

  - ### setToolTipTextAt

    @BeanProperty(preferred=true, description="The tooltip text at the specified tab index.") public void setToolTipTextAt(int index, String toolTipText)
    Sets the tooltip text at `index` to `toolTipText` which can be `null`. An internal exception is raised if there is no tab at that index.
    Parameters:
      `index` - the tab index where the tooltip text should be set
      `toolTipText` - the tooltip text to be displayed for the tab
    Throws:
      `IndexOutOfBoundsException` - if index is out of range `(index < 0 || index >= tab count)`
    Since:
      1.3
    See Also:
      - `getToolTipTextAt(int)`

  - ### setBackgroundAt

    @BeanProperty(preferred=true, visualUpdate=true, description="The background color at the specified tab index.") public void setBackgroundAt(int index, Color background)
    Sets the background color at `index` to `background` which can be `null`, in which case the tab's background color will default to the background color of the `tabbedpane`. An internal exception is raised if there is no tab at that index.

    It is up to the look and feel to honor this property, some may choose to ignore it.

    Parameters:
      `index` - the tab index where the background should be set
      `background` - the color to be displayed in the tab's background
    Throws:
      `IndexOutOfBoundsException` - if index is out of range `(index < 0 || index >= tab count)`
    See Also:
      - `getBackgroundAt(int)`

  - ### setForegroundAt

    @BeanProperty(preferred=true, visualUpdate=true, description="The foreground color at the specified tab index.") public void setForegroundAt(int index, Color foreground)
    Sets the foreground color at `index` to `foreground` which can be `null`, in which case the tab's foreground color will default to the foreground color of this `tabbedpane`. An internal exception is raised if there is no tab at that index.

    It is up to the look and feel to honor this property, some may choose to ignore it.

    Parameters:
      `index` - the tab index where the foreground should be set
      `foreground` - the color to be displayed as the tab's foreground
    Throws:
      `IndexOutOfBoundsException` - if index is out of range `(index < 0 || index >= tab count)`
    See Also:
      - `getForegroundAt(int)`

  - ### setEnabledAt

    public void setEnabledAt(int index, boolean enabled)
    Sets whether or not the tab at `index` is enabled. An internal exception is raised if there is no tab at that index.
    Parameters:
      `index` - the tab index which should be enabled/disabled
      `enabled` - whether or not the tab should be enabled
    Throws:
      `IndexOutOfBoundsException` - if index is out of range `(index < 0 || index >= tab count)`
    See Also:
      - `isEnabledAt(int)`

  - ### setComponentAt

    @BeanProperty(visualUpdate=true, description="The component at the specified tab index.") public void setComponentAt(int index, Component component)
    Sets the component at `index` to `component`. An internal exception is raised if there is no tab at that index.
    Parameters:
      `index` - the tab index where this component is being placed
      `component` - the component for the tab
    Throws:
      `IndexOutOfBoundsException` - if index is out of range `(index < 0 || index >= tab count)`
    See Also:
      - `getComponentAt(int)`

  - ### setDisplayedMnemonicIndexAt

    @BeanProperty(visualUpdate=true, description="the index into the String to draw the keyboard character mnemonic at") public void setDisplayedMnemonicIndexAt(int tabIndex, int mnemonicIndex)
    Provides a hint to the look and feel as to which character in the text should be decorated to represent the mnemonic. Not all look and feels may support this. A value of -1 indicates either there is no mnemonic for this tab, or you do not wish the mnemonic to be displayed for this tab.

    The value of this is updated as the properties relating to the mnemonic change (such as the mnemonic itself, the text...). You should only ever have to call this if you do not wish the default character to be underlined. For example, if the text at tab index 3 was 'Apple Price', with a mnemonic of 'p', and you wanted the 'P' to be decorated, as 'Apple Price', you would have to invoke `setDisplayedMnemonicIndex(3, 6)` after invoking `setMnemonicAt(3, KeyEvent.VK_P)`.

    Note that it is the programmer's responsibility to ensure that each tab has a unique mnemonic or unpredictable results may occur.

    Parameters:
      `tabIndex` - the index of the tab that the mnemonic refers to
      `mnemonicIndex` - index into the `String` to underline
    Throws:
      `IndexOutOfBoundsException` - if `tabIndex` is out of range (`tabIndex < 0 || tabIndex >= tab count`)
      `IllegalArgumentException` - will be thrown if `mnemonicIndex` is >= length of the tab title , or < -1
    Since:
      1.4
    See Also:
      - `setMnemonicAt(int,int)`
      - `getDisplayedMnemonicIndexAt(int)`

  - ### setMnemonicAt

    @BeanProperty(visualUpdate=true, description="The keyboard mnenmonic, as a KeyEvent VK constant, for the specified tab") public void setMnemonicAt(int tabIndex, int mnemonic)
    Sets the keyboard mnemonic for accessing the specified tab. The mnemonic is the key which when combined with the look and feel's mouseless modifier (usually Alt) will activate the specified tab.

    A mnemonic must correspond to a single key on the keyboard and should be specified using one of the `VK_XXX` keycodes defined in `java.awt.event.KeyEvent` or one of the extended keycodes obtained through `java.awt.event.KeyEvent.getExtendedKeyCodeForChar`. Mnemonics are case-insensitive, therefore a key event with the corresponding keycode would cause the button to be activated whether or not the Shift modifier was pressed.

    This will update the displayed mnemonic property for the specified tab.

    Parameters:
      `tabIndex` - the index of the tab that the mnemonic refers to
      `mnemonic` - the key code which represents the mnemonic
    Throws:
      `IndexOutOfBoundsException` - if `tabIndex` is out of range (`tabIndex < 0 || tabIndex >= tab count`)
    Since:
      1.4
    See Also:
      - `getMnemonicAt(int)`
      - `setDisplayedMnemonicIndexAt(int,int)`

  - ### indexOfTab

    public int indexOfTab(String title)
    Returns the first tab index with a given `title`, or -1 if no tab has this title.
    Parameters:
      `title` - the title for the tab
    Returns:
      the first tab index which matches `title`, or -1 if no tab has this title

  - ### indexOfTab

    public int indexOfTab(Icon icon)
    Returns the first tab index with a given `icon`, or -1 if no tab has this icon.
    Parameters:
      `icon` - the icon for the tab
    Returns:
      the first tab index which matches `icon`, or -1 if no tab has this icon

  - ### indexOfComponent

    public int indexOfComponent(Component component)
    Returns the index of the tab for the specified component. Returns -1 if there is no tab for this component.
    Parameters:
      `component` - the component for the tab
    Returns:
      the first tab which matches this component, or -1 if there is no tab for this component

  - ### indexAtLocation

    public int indexAtLocation(int x, int y)
    Returns the tab index corresponding to the tab whose bounds intersect the specified location. Returns -1 if no tab intersects the location.
    Parameters:
      `x` - the x location relative to this tabbedpane
      `y` - the y location relative to this tabbedpane
    Returns:
      the tab index which intersects the location, or -1 if no tab intersects the location
    Since:
      1.4

  - ### getToolTipText

    public String getToolTipText(MouseEvent event)
    Returns the tooltip text for the component determined by the mouse event location.
    Overrides:
      `getToolTipText` in class `JComponent`
    Parameters:
      `event` - the `MouseEvent` that tells where the cursor is lingering
    Returns:
      the `String` containing the tooltip text

  - ### paramString

    protected String paramString()
    Returns a string representation of this `JTabbedPane`. This method is intended to be used only for debugging purposes, and the content and format of the returned string may vary between implementations. The returned string may be empty but may not be `null`.
    Overrides:
      `paramString` in class `JComponent`
    Returns:
      a string representation of this JTabbedPane.

  - ### getAccessibleContext

    @BeanProperty(bound=false) public AccessibleContext getAccessibleContext()
    Gets the AccessibleContext associated with this JTabbedPane. For tabbed panes, the AccessibleContext takes the form of an AccessibleJTabbedPane. A new AccessibleJTabbedPane instance is created if necessary.
    Specified by:
      `getAccessibleContext` in interface `Accessible`
    Overrides:
      `getAccessibleContext` in class `Component`
    Returns:
      an AccessibleJTabbedPane that serves as the AccessibleContext of this JTabbedPane

  - ### setTabComponentAt

    @BeanProperty(preferred=true, visualUpdate=true, description="The tab component at the specified tab index.") public void setTabComponentAt(int index, Component component)
    Sets the component that is responsible for rendering the title for the specified tab. A null value means `JTabbedPane` will render the title and/or icon for the specified tab. A non-null value means the component will render the title and `JTabbedPane` will not render the title and/or icon.

    Note: The component must not be one that the developer has already added to the tabbed pane.

    Parameters:
      `index` - the tab index where the component should be set
      `component` - the component to render the title for the specified tab
    Throws:
      `IndexOutOfBoundsException` - if index is out of range `(index < 0 || index >= tab count)`
      `IllegalArgumentException` - if component has already been added to this `JTabbedPane`
    Since:
      1.6
    See Also:
      - `getTabComponentAt(int)`

  - ### getTabComponentAt

    public Component getTabComponentAt(int index)
    Returns the tab component at `index`.
    Parameters:
      `index` - the index of the item being queried
    Returns:
      the tab component at `index`
    Throws:
      `IndexOutOfBoundsException` - if index is out of range `(index < 0 || index >= tab count)`
    Since:
      1.6
    See Also:
      - `setTabComponentAt(int, Component)`

  - ### indexOfTabComponent

    public int indexOfTabComponent(Component tabComponent)
    Returns the index of the tab for the specified tab component. Returns -1 if there is no tab for this tab component.
    Parameters:
      `tabComponent` - the tab component for the tab
    Returns:
      the first tab which matches this tab component, or -1 if there is no tab for this tab component
    Since:
      1.6
    See Also:
      - `setTabComponentAt(int, Component)`
      - `getTabComponentAt(int)`